diff -urN linux.store/linux/Makefile linux/Makefile
--- linux.store/linux/Makefile	Wed Mar 13 23:54:56 1996
+++ linux/Makefile	Wed Mar 27 10:22:38 1996
@@ -251,7 +251,7 @@
 	rm -f .tmp* drivers/sound/configure
 	rm -fr modules/*
 
-mrproper: clean
+mrproper:: clean
 	rm -f include/linux/autoconf.h include/linux/version.h
 	rm -f drivers/sound/local.h
 	rm -f drivers/scsi/aic7xxx_asm drivers/scsi/aic7xxx_seq.h
diff -urN linux.store/linux/README.arm linux/README.arm
--- linux.store/linux/README.arm	Wed Mar 13 23:54:56 1996
+++ linux/README.arm	Thu Mar 28 14:12:36 1996
@@ -33,3 +33,26 @@
 Name: Ian Jeffray
 Mail: ian_jeffray@MENTORG.COM
 Desc: A3/4/5xx serial and parrallel port code maintainer.
+
+
+Notes
+-----
+ST506 hard drives
+-----------------
+The ST506 hard drive controllers seem to be working fine (if
+a bit slowly).  At the moment they will only work off the
+controllers on an A4x0's motherboard, but for it to work
+off a Podule just requires someone with a podule to add the
+addresses for the IRQ mask and the HDC base to the source.
+
+Oh yes - the drive busy light seems to stay on all the time;
+suggestions welcome!
+
+1772 Floppy
+-----------
+This also seems to work OK, but hasn't been stressed much lately.
+It hasn't got any code for disc change detection in there at the
+moment which could be a bit of a problem!  Suggestions on the
+correct way to do this are welcome.
+
+
diff -urN linux.store/linux/arch/arm/Makefile linux/arch/arm/Makefile
--- linux.store/linux/arch/arm/Makefile	Wed Mar 13 23:54:57 1996
+++ linux/arch/arm/Makefile	Thu Mar 28 11:58:22 1996
@@ -14,7 +14,7 @@
 #
 # Since we are going multi-computer, I think that this ought to reflect it...
 #
-# THIS IS MY PATCHLEVEL:  PATCHLEVEL2
+# THIS IS MY PATCHLEVEL:  PATCHLEVEL3
 
 # MACHINE can be: arc a5k rpc
 # PROCESSOR can be: arm2 arm3 arm6
@@ -84,6 +84,10 @@
 	rm -f include/asm-arm/arch include/asm-arm/proc
 	(cd include/asm-arm; ln -sf arch-$(MACHINE) arch; ln -sf proc-$(PROCESSOR) proc)
 
+mrproper::
+	rm -f include/asm-arm/arch include/asm-arm/proc
+	@$(MAKE) -C arch/$(ARCH)/drivers mrproper
+
 install:
 	@$(MAKEBOOT) install
 
@@ -95,11 +99,6 @@
 
 archclean:
 	@$(MAKEBOOT) clean
-	@$(MAKE) -C arch/$(ARCH)/drivers/block LINKCLEAN
-	@$(MAKE) -C arch/$(ARCH)/drivers/char LINKCLEAN
-	@$(MAKE) -C arch/$(ARCH)/drivers/net LINKCLEAN
-	@$(MAKE) -C arch/$(ARCH)/drivers/scsi LINKCLEAN
-	rm -f include/asm-arm/arch include/asm-arm/proc
 
 archdep:
 	@$(MAKEBOOT) dep
diff -urN linux.store/linux/arch/arm/drivers/Makefile linux/arch/arm/drivers/Makefile
--- linux.store/linux/arch/arm/drivers/Makefile	Sun Feb 11 09:32:13 1996
+++ linux/arch/arm/drivers/Makefile	Thu Mar 28 11:51:08 1996
@@ -31,3 +31,7 @@
 endif
 
 include $(TOPDIR)/Rules.make
+
+mrproper:
+	set -e; for i in $(ALL_SUB_DIRS); do $(MAKE) -C $$i mrproper; done
+
diff -urN linux.store/linux/arch/arm/drivers/block/Makefile linux/arch/arm/drivers/block/Makefile
--- linux.store/linux/arch/arm/drivers/block/Makefile	Wed Mar 13 23:54:58 1996
+++ linux/arch/arm/drivers/block/Makefile	Thu Mar 28 11:52:14 1996
@@ -65,9 +65,12 @@
 	done
 	touch links
 
-LINKCLEAN:
+mrproper:
 	-@for f in $(LK); do \
-		if [ -L $$f ]; then rm -f $$f; fi; \
+		if [ -L $$f ]; then \
+			echo $(RM) $$f; \
+			$(RM) $$f; \
+		fi; \
 	done
-	rm -f links
+	$(RM) links
 
diff -urN linux.store/linux/arch/arm/drivers/block/blk.h linux/arch/arm/drivers/block/blk.h
--- linux.store/linux/arch/arm/drivers/block/blk.h	Thu Jan  1 01:00:00 1970
+++ linux/arch/arm/drivers/block/blk.h	Thu Mar 28 15:06:37 1996
@@ -0,0 +1,402 @@
+#ifndef _BLK_H
+#define _BLK_H
+
+#include <linux/blkdev.h>
+#include <linux/locks.h>
+#include <linux/config.h>
+
+/*
+ * NR_REQUEST is the number of entries in the request-queue.
+ * NOTE that writes may use only the low 2/3 of these: reads
+ * take precedence.
+ */
+#define NR_REQUEST	64
+
+/*
+ * This is used in the elevator algorithm: Note that
+ * reads always go before writes. This is natural: reads
+ * are much more time-critical than writes.
+ */
+#define IN_ORDER(s1,s2) \
+((s1)->cmd < (s2)->cmd || ((s1)->cmd == (s2)->cmd && \
+((s1)->rq_dev < (s2)->rq_dev || (((s1)->rq_dev == (s2)->rq_dev && \
+(s1)->sector < (s2)->sector)))))
+
+/*
+ * These will have to be changed to be aware of different buffer
+ * sizes etc.. It actually needs a major cleanup.
+ */
+#ifdef IDE_DRIVER
+#define SECTOR_MASK ((BLOCK_SIZE >> 9) - 1)
+#else
+#define SECTOR_MASK (blksize_size[MAJOR_NR] &&     \
+	blksize_size[MAJOR_NR][MINOR(CURRENT->rq_dev)] ? \
+	((blksize_size[MAJOR_NR][MINOR(CURRENT->rq_dev)] >> 9) - 1) :  \
+	((BLOCK_SIZE >> 9)  -  1))
+#endif /* IDE_DRIVER */
+
+#define SUBSECTOR(block) (CURRENT->current_nr_sectors > 0)
+
+#ifdef CONFIG_CDU31A
+extern int cdu31a_init(void);
+#endif CONFIG_CDU31A
+#ifdef CONFIG_MCD
+extern int mcd_init(void);
+#endif CONFIG_MCD
+#ifdef CONFIG_MCDX
+extern int mcdx_init(void);
+#endif CONFIG_MCDX
+#ifdef CONFIG_SBPCD
+extern int sbpcd_init(void);
+#endif CONFIG_SBPCD
+#ifdef CONFIG_AZTCD
+extern int aztcd_init(void);
+#endif CONFIG_AZTCD
+#ifdef CONFIG_CDU535
+extern int sony535_init(void);
+#endif CONFIG_CDU535
+#ifdef CONFIG_GSCD
+extern int gscd_init(void);
+#endif CONFIG_GSCD
+#ifdef CONFIG_CM206
+extern int cm206_init(void);
+#endif CONFIG_CM206
+#ifdef CONFIG_OPTCD
+extern int optcd_init(void);
+#endif CONFIG_OPTCD
+#ifdef CONFIG_SJCD
+extern int sjcd_init(void);
+#endif CONFIG_SJCD
+#ifdef CONFIG_BLK_DEV_HD
+extern int hd_init(void);
+#endif
+#ifdef CONFIG_BLK_DEV_IDE
+extern int ide_init(void);
+#endif
+#ifdef CONFIG_BLK_DEV_XD
+extern int xd_init(void);
+#endif
+
+extern void set_device_ro(kdev_t dev,int flag);
+
+extern int floppy_init(void);
+extern void rd_load(void);
+extern long rd_init(long mem_start, int length);
+extern int ramdisk_size;
+
+#define RO_IOCTLS(dev,where) \
+  case BLKROSET: if (!suser()) return -EACCES; \
+		 set_device_ro((dev),get_fs_long((long *) (where))); return 0; \
+  case BLKROGET: { int __err = verify_area(VERIFY_WRITE, (void *) (where), sizeof(long)); \
+		   if (!__err) put_fs_long(0!=is_read_only(dev),(long *) (where)); return __err; }
+		 
+#if defined(MAJOR_NR) || defined(IDE_DRIVER)
+
+/*
+ * Add entries as needed.
+ */
+
+#ifdef IDE_DRIVER
+
+#define DEVICE_NR(device)	(MINOR(device) >> PARTN_BITS)
+#define DEVICE_ON(device)	/* nothing */
+#define DEVICE_OFF(device)	/* nothing */
+
+#elif (MAJOR_NR == MEM_MAJOR)
+
+/* ram disk */
+#define DEVICE_NAME "ramdisk"
+#define DEVICE_REQUEST do_rd_request
+#define DEVICE_NR(device) (MINOR(device) & 7)
+#define DEVICE_ON(device) 
+#define DEVICE_OFF(device)
+
+#elif (MAJOR_NR == FLOPPY_MAJOR)
+
+static void floppy_off(unsigned int nr);
+
+#define DEVICE_NAME "floppy"
+#define DEVICE_INTR do_floppy
+#define DEVICE_REQUEST do_fd_request
+#define DEVICE_NR(device) ( (MINOR(device) & 3) | ((MINOR(device) & 0x80 ) >> 5 ))
+#define DEVICE_ON(device)
+#define DEVICE_OFF(device) floppy_off(DEVICE_NR(device))
+
+#elif (MAJOR_NR == HD_MAJOR)
+
+/* harddisk: timeout is 6 seconds.. */
+#define DEVICE_NAME "harddisk"
+#define DEVICE_INTR do_hd
+#define DEVICE_TIMEOUT HD_TIMER
+#define TIMEOUT_VALUE (6*HZ)
+#define DEVICE_REQUEST do_hd_request
+#define DEVICE_NR(device) (MINOR(device)>>6)
+#define DEVICE_ON(device)
+#define DEVICE_OFF(device)
+
+#elif (MAJOR_NR == SCSI_DISK_MAJOR)
+
+#define DEVICE_NAME "scsidisk"
+#define DEVICE_INTR do_sd  
+#define TIMEOUT_VALUE (2*HZ)
+#define DEVICE_REQUEST do_sd_request
+#define DEVICE_NR(device) (MINOR(device) >> 4)
+#define DEVICE_ON(device)
+#define DEVICE_OFF(device)
+
+#elif (MAJOR_NR == SCSI_TAPE_MAJOR)
+
+#define DEVICE_NAME "scsitape"
+#define DEVICE_INTR do_st  
+#define DEVICE_NR(device) (MINOR(device) & 0x7f)
+#define DEVICE_ON(device)
+#define DEVICE_OFF(device)
+
+#elif (MAJOR_NR == SCSI_CDROM_MAJOR)
+
+#define DEVICE_NAME "CD-ROM"
+#define DEVICE_INTR do_sr
+#define DEVICE_REQUEST do_sr_request
+#define DEVICE_NR(device) (MINOR(device))
+#define DEVICE_ON(device)
+#define DEVICE_OFF(device)
+
+#elif (MAJOR_NR == XT_DISK_MAJOR)
+
+#define DEVICE_NAME "xt disk"
+#define DEVICE_REQUEST do_xd_request
+#define DEVICE_NR(device) (MINOR(device) >> 6)
+#define DEVICE_ON(device)
+#define DEVICE_OFF(device)
+
+#elif defined(MFM_DISK_MAJOR) && (MAJOR_NR == MFM_DISK_MAJOR)
+
+#define DEVICE_NAME "mfm disk"
+#define DEVICE_INTR do_mfm
+#define DEVICE_REQUEST do_mfm_request
+#define DEVICE_NR(device) (MINOR(device) >> 6)
+#define DEVICE_ON(device)
+#define DEVICE_OFF(device)
+
+#elif (MAJOR_NR == CDU31A_CDROM_MAJOR)
+
+#define DEVICE_NAME "CDU31A"
+#define DEVICE_REQUEST do_cdu31a_request
+#define DEVICE_NR(device) (MINOR(device))
+#define DEVICE_ON(device)
+#define DEVICE_OFF(device)
+
+#elif (MAJOR_NR == MITSUMI_CDROM_MAJOR)
+
+#define DEVICE_NAME "Mitsumi CD-ROM"
+/* #define DEVICE_INTR do_mcd */
+#define DEVICE_REQUEST do_mcd_request
+#define DEVICE_NR(device) (MINOR(device))
+#define DEVICE_ON(device)
+#define DEVICE_OFF(device)
+
+#elif (MAJOR_NR == MITSUMI_X_CDROM_MAJOR)
+
+#define DEVICE_NAME "Mitsumi CD-ROM"
+/* #define DEVICE_INTR do_mcdx */
+#define DEVICE_REQUEST do_mcdx_request
+#define DEVICE_NR(device) (MINOR(device))
+#define DEVICE_ON(device)
+#define DEVICE_OFF(device)
+
+#elif (MAJOR_NR == MATSUSHITA_CDROM_MAJOR)
+
+#define DEVICE_NAME "Matsushita CD-ROM controller #1"
+#define DEVICE_REQUEST do_sbpcd_request
+#define DEVICE_NR(device) (MINOR(device))
+#define DEVICE_ON(device)
+#define DEVICE_OFF(device)
+
+#elif (MAJOR_NR == MATSUSHITA_CDROM2_MAJOR)
+
+#define DEVICE_NAME "Matsushita CD-ROM controller #2"
+#define DEVICE_REQUEST do_sbpcd2_request
+#define DEVICE_NR(device) (MINOR(device))
+#define DEVICE_ON(device)
+#define DEVICE_OFF(device)
+
+#elif (MAJOR_NR == MATSUSHITA_CDROM3_MAJOR)
+
+#define DEVICE_NAME "Matsushita CD-ROM controller #3"
+#define DEVICE_REQUEST do_sbpcd3_request
+#define DEVICE_NR(device) (MINOR(device))
+#define DEVICE_ON(device)
+#define DEVICE_OFF(device)
+
+#elif (MAJOR_NR == MATSUSHITA_CDROM4_MAJOR)
+
+#define DEVICE_NAME "Matsushita CD-ROM controller #4"
+#define DEVICE_REQUEST do_sbpcd4_request
+#define DEVICE_NR(device) (MINOR(device))
+#define DEVICE_ON(device)
+#define DEVICE_OFF(device)
+
+#elif (MAJOR_NR == AZTECH_CDROM_MAJOR)
+
+#define DEVICE_NAME "Aztech CD-ROM"
+#define DEVICE_REQUEST do_aztcd_request
+#define DEVICE_NR(device) (MINOR(device))
+#define DEVICE_ON(device)
+#define DEVICE_OFF(device)
+
+#elif (MAJOR_NR == CDU535_CDROM_MAJOR)
+
+#define DEVICE_NAME "SONY-CDU535"
+#define DEVICE_INTR do_cdu535
+#define DEVICE_REQUEST do_cdu535_request
+#define DEVICE_NR(device) (MINOR(device))
+#define DEVICE_ON(device)
+#define DEVICE_OFF(device)
+
+#elif (MAJOR_NR == GOLDSTAR_CDROM_MAJOR)
+
+#define DEVICE_NAME "Goldstar R420"
+#define DEVICE_REQUEST do_gscd_request
+#define DEVICE_NR(device) (MINOR(device))
+#define DEVICE_ON(device)
+#define DEVICE_OFF(device)
+
+#elif (MAJOR_NR == CM206_CDROM_MAJOR)
+#define DEVICE_NAME "Philips/LMS cd-rom cm206"
+#define DEVICE_REQUEST do_cm206_request
+#define DEVICE_NR(device) (MINOR(device))
+#define DEVICE_ON(device)
+#define DEVICE_OFF(device)
+
+#elif (MAJOR_NR == OPTICS_CDROM_MAJOR)
+
+#define DEVICE_NAME "DOLPHIN 8000AT CD-ROM"
+#define DEVICE_REQUEST do_optcd_request
+#define DEVICE_NR(device) (MINOR(device))
+#define DEVICE_ON(device)
+#define DEVICE_OFF(device)
+
+#elif (MAJOR_NR == SANYO_CDROM_MAJOR)
+
+#define DEVICE_NAME "Sanyo H94A CD-ROM"
+#define DEVICE_REQUEST do_sjcd_request
+#define DEVICE_NR(device) (MINOR(device))
+#define DEVICE_ON(device)
+#define DEVICE_OFF(device)
+
+#endif /* MAJOR_NR == whatever */
+
+#if (MAJOR_NR != SCSI_TAPE_MAJOR) && !defined(IDE_DRIVER)
+
+#ifndef CURRENT
+#define CURRENT (blk_dev[MAJOR_NR].current_request)
+#endif
+
+#define CURRENT_DEV DEVICE_NR(CURRENT->rq_dev)
+
+#ifdef DEVICE_INTR
+void (*DEVICE_INTR)(void) = NULL;
+#endif
+#ifdef DEVICE_TIMEOUT
+
+#define SET_TIMER \
+((timer_table[DEVICE_TIMEOUT].expires = jiffies + TIMEOUT_VALUE), \
+(timer_active |= 1<<DEVICE_TIMEOUT))
+
+#define CLEAR_TIMER \
+timer_active &= ~(1<<DEVICE_TIMEOUT)
+
+#define SET_INTR(x) \
+if ((DEVICE_INTR = (x)) != NULL) \
+	SET_TIMER; \
+else \
+	CLEAR_TIMER;
+
+#else
+
+#define SET_INTR(x) (DEVICE_INTR = (x))
+
+#endif /* DEVICE_TIMEOUT */
+
+static void (DEVICE_REQUEST)(void);
+
+#ifdef DEVICE_INTR
+#define CLEAR_INTR SET_INTR(NULL)
+#else
+#define CLEAR_INTR
+#endif
+
+#define INIT_REQUEST \
+	if (!CURRENT) {\
+		CLEAR_INTR; \
+		return; \
+	} \
+	if (MAJOR(CURRENT->rq_dev) != MAJOR_NR) \
+		panic(DEVICE_NAME ": request list destroyed"); \
+	if (CURRENT->bh) { \
+		if (!CURRENT->bh->b_lock) \
+			panic(DEVICE_NAME ": block not locked"); \
+	}
+
+#endif /* (MAJOR_NR != SCSI_TAPE_MAJOR) && !defined(IDE_DRIVER) */
+
+/* end_request() - SCSI devices have their own version */
+/*               - IDE drivers have their own copy too */
+
+#if ! SCSI_MAJOR(MAJOR_NR)
+
+#if defined(_IDE_CD_C) || defined(_TRITON_C) /* shares copy with ide.c */
+void ide_end_request(byte uptodate, ide_hwgroup_t *hwgroup);
+#else
+
+#ifdef IDE_DRIVER
+void ide_end_request(byte uptodate, ide_hwgroup_t *hwgroup) {
+	struct request *req = hwgroup->rq;
+#else
+static void end_request(int uptodate) {
+	struct request *req = CURRENT;
+#endif /* IDE_DRIVER */
+	struct buffer_head * bh;
+
+	req->errors = 0;
+	if (!uptodate) {
+		printk("end_request: I/O error, dev %s, sector %lu\n",
+			kdevname(req->rq_dev), req->sector);
+		req->nr_sectors--;
+		req->nr_sectors &= ~SECTOR_MASK;
+		req->sector += (BLOCK_SIZE / 512);
+		req->sector &= ~SECTOR_MASK;		
+	}
+
+	if ((bh = req->bh) != NULL) {
+		req->bh = bh->b_reqnext;
+		bh->b_reqnext = NULL;
+		bh->b_uptodate = uptodate;		
+		unlock_buffer(bh);
+		if ((bh = req->bh) != NULL) {
+			req->current_nr_sectors = bh->b_size >> 9;
+			if (req->nr_sectors < req->current_nr_sectors) {
+				req->nr_sectors = req->current_nr_sectors;
+				printk("end_request: buffer-list destroyed\n");
+			}
+			req->buffer = bh->b_data;
+			return;
+		}
+	}
+#ifdef IDE_DRIVER
+	hwgroup->rq = NULL;
+#else
+	DEVICE_OFF(req->rq_dev);
+	CURRENT = req->next;
+#endif /* IDE_DRIVER */
+	if (req->sem != NULL)
+		up(req->sem);
+	req->rq_status = RQ_INACTIVE;
+	wake_up(&wait_for_request);
+}
+#endif /* ndef _IDE_CD_C */
+#endif /* ! SCSI_MAJOR(MAJOR_NR) */
+
+#endif /* defined(MAJOR_NR) || defined(IDE_DRIVER) */
+
+#endif /* _BLK_H */
diff -urN linux.store/linux/arch/arm/drivers/block/fd1772.c linux/arch/arm/drivers/block/fd1772.c
--- linux.store/linux/arch/arm/drivers/block/fd1772.c	Wed Mar 13 23:54:58 1996
+++ linux/arch/arm/drivers/block/fd1772.c	Thu Mar 28 14:12:36 1996
@@ -95,7 +95,7 @@
 #include <linux/delay.h>
 #include <linux/mm.h>
 
-#include <asm/machdeps.h>
+#include <asm/arch/oldlatches.h>
 #include <asm/system.h>
 #include <asm/bitops.h>
 #include <asm/dma.h>
@@ -1387,8 +1387,8 @@
 };
 
 
-void
-fd1772_init (void)
+int
+floppy_init (void)
 
 {	int i;
 
@@ -1444,5 +1444,10 @@
 
 	config_types();
 
-	return ;
+	return 0;
+}
+
+/* Just a dummy at the moment */
+void floppy_setup(char *str, int *ints)
+{
 }
diff -urN linux.store/linux/arch/arm/drivers/block/genhd.c linux/arch/arm/drivers/block/genhd.c
--- linux.store/linux/arch/arm/drivers/block/genhd.c	Sun Mar  3 12:22:14 1996
+++ linux/arch/arm/drivers/block/genhd.c	Tue Mar 26 23:19:47 1996
@@ -416,6 +416,12 @@
 	printk(" ");
 	print_minor_name(hd, MINOR(dev));
 
+	/*
+	 * Currently there is a problem with ADFS disks having been
+	 * formatted as a DOS disk.  This leaves the old DOS partition
+	 * behind.
+	 */
+
 #ifdef CONFIG_MSDOS_PARTITION
 	if (msdos_partition(hd, dev, first_sector))
 		return;
@@ -426,15 +432,18 @@
 	printk(" unknown partition table\n");
 }
 
-/* This function is used to re-read partition tables for removable disks.
-   Much of the cleanup from the old partition tables should have already been
-   done */
-
-/* This function will re-read the partition tables for a given device,
-and set things back up again.  There are some important caveats,
-however.  You must ensure that no one is using the device, and no one
-can start using the device while this function is being executed. */
+/*
+ * This function is used to re-read partition tables for removable disks.
+ * Much of the cleanup from the old partition tables should have already been
+ * done
+ */
 
+/*
+ * This function will re-read the partition tables for a given device,
+ * and set things back up again.  There are some important caveats,
+ * however.  You must ensure that no one is using the device, and no one
+ * can start using the device while this function is being executed.
+ */
 void resetup_one_dev(struct gendisk *dev, int drive)
 {
 	int i;
diff -urN linux.store/linux/arch/arm/drivers/block/hd.c linux/arch/arm/drivers/block/hd.c
--- linux.store/linux/arch/arm/drivers/block/hd.c	Thu Mar 14 11:45:05 1996
+++ linux/arch/arm/drivers/block/hd.c	Fri Mar 22 23:51:58 1996
@@ -26,7 +26,7 @@
  */
 
 /* This is the maximum number of fragments accessed in one go */
-int no_hds;
+extern int number_ide_drives;
 #define MAX_FRAGS	16
 static unsigned long frag_start[MAX_FRAGS];	/* Start of fragments */
 static unsigned long frag_len[MAX_FRAGS];	/* Fragment length */
@@ -827,7 +827,7 @@
 int issue_request(int dev, unsigned int block, unsigned int nsect, struct request *current_req)
 {
 	unsigned int sec, track, head, cyl;
-	int d = dev;
+
 	dev >>= 6;
 	if (special_op[dev]) {
 		if (do_special_op(dev))
@@ -1111,7 +1111,7 @@
 	 * We only set this to the one that the host OS gave us
 	 * if the user has not defined any types.
 	 */
-	NR_HD = no_hds;
+	NR_HD = number_ide_drives;
     }
 
     i = NR_HD;
diff -urN linux.store/linux/arch/arm/drivers/block/hdsrch.c linux/arch/arm/drivers/block/hdsrch.c
--- linux.store/linux/arch/arm/drivers/block/hdsrch.c	Wed Mar 13 23:54:59 1996
+++ linux/arch/arm/drivers/block/hdsrch.c	Thu Mar 28 14:19:13 1996
@@ -17,8 +17,9 @@
 #include <linux/string.h>
 #include <linux/genhd.h>
 
-#define RECSIZE 60
+#define DEBUG_UNINIT
 
+#define RECSIZE 60
 #define MAX_BLK_FRAGS 64
 
 struct boot_block
@@ -89,7 +90,7 @@
 #endif
 
 #ifdef CONFIG_BLK_DEV_XD
-    case XD_MAJOR:
+    case XT_DISK_MAJOR:
 	xd_set_geometry (dev, sectspertrack, heads, disksize, sectorsize);
 	break;
 #endif
@@ -408,8 +409,17 @@
 #define MAX_HD_IMAGES	8
 #define MAX_HD_BITS	128
 
+#ifdef DEBUG_UNINIT
+static unsigned long __magic_1 = 0xf8149512;
+#endif
 static int initialised[MAX_HD_IMAGES];
+#ifdef DEBUG_UNINIT
+static unsigned long __magic_2 = 0x15f73b2c;
+#endif
 static int maxblock[MAX_HD_IMAGES];
+#ifdef DEBUG_UNINIT
+static unsigned long __magic_3 = 0x9bd4a56e;
+#endif
 static unsigned long startchk[MAX_HD_IMAGES],lengthchk[MAX_HD_IMAGES];
 #ifndef NOT_YET_TESTED
 static unsigned long startaddr[MAX_HD_IMAGES][MAX_HD_BITS],
@@ -418,7 +428,6 @@
 static unsigned long *startaddr[MAX_HD_IMAGES],
                     *lengthaddr[MAX_HD_IMAGES];
 #endif
-
 /* --------------------------------------------------------------------------------- */
 /*  Externally visible functions/variables
  * --------------------------------------------------------------------------------- */
@@ -444,7 +453,7 @@
 #ifdef CONFIG_BLK_DEV_HD
     case HD_MAJOR:	/* IDE drives */
 #elif defined(CONFIG_BLK_DEV_XD)
-    case XD_MAJOR:	/* ST506 drives (map onto IDE at the moment) */
+    case XT_DISK_MAJOR:	/* ST506 drives (map onto IDE at the moment) */
 #endif
 	if ((MINOR(dev) & 0x3f) < 1 || (MINOR(dev) & 0x3f) > 0x14) {
 	    printk ("%s: bad device %s\n", where, kdevname (dev));
@@ -476,7 +485,7 @@
 #ifdef CONFIG_BLK_DEV_HD
     case HD_MAJOR:	/* IDE drives */
 #elif defined(CONFIG_BLK_DEV_XD)
-    case XD_MAJOR:	/* ST506 drives (map onto IDE at the moment) */
+    case XT_DISK_MAJOR:	/* ST506 drives (map onto IDE at the moment) */
 #endif	
 	switch (MINOR(dev) & 0xc0) {
 	case 0x00:
@@ -521,8 +530,10 @@
     if (maxblock[devno] > MAX_HD_BITS)
 	panic ("image_allocate_list: image file is too fragmented\n");
 
-    if (!maxblock[devno])
+    if (!maxblock[devno]) {
+    	printk ("image_allocate_list: zero length image file\n");
 	return 0;
+    }
 
     for (i = 0; i < maxblock[devno]; i++) {
 	/* convert to blocks & calculate checksums */
@@ -583,8 +594,27 @@
 	return 0;
 
     if (!initialised[internal_dev]) {
-	printk ("hd%c%d: %s of uninitialised image file.\n",
-	    (dev >> 6) + 'a', dev & 0x3f, cmd == WRITE ? "write" : "read");
+	printk ("\n%s: %s of uninitialised image file.\n",
+	    kdevname (dev), cmd == WRITE ? "write" : "read");
+#ifdef DEBUG_UNINIT
+	{
+	    printk ("(id=%d", internal_dev);
+	    for (i = 0; i < 8; i++)
+	    	printk (" init[%d]=%d", i, initialised[i]);
+	    printk (")\n");
+	    printk ("__magic_1 = 0x%08lx ", __magic_1);
+	    if (__magic_1 != 0xf8149512)
+		printk ("(bad)");
+	    printk ("\n__magic_2 = 0x%08lx ", __magic_2);
+	    if (__magic_2 != 0x15f73b2c)
+		printk ("(bad)");
+	    printk ("\n__magic_3 = 0x%08lx ", __magic_3);
+	    if (__magic_3 != 0x9bd4a56e)
+	        printk ("(bad)");
+	    printk ("\n");
+	}
+	while (1);
+#endif
 	return 0;
     }
 
@@ -598,8 +628,8 @@
 	    chk2 ^= lengthaddr[internal_dev][i];
 	}
 	if (chk1 != startchk[internal_dev] || chk2 != lengthchk[internal_dev]) {
-	    printk ("hda%c%d: mapping tables corrupted on write.",
-			(dev >> 6) + 'a', dev & 0x3f);
+	    printk ("%s: mapping tables corrupted on write.",
+			kdevname (dev));
 	    return 0;
 	}
     }
@@ -644,8 +674,8 @@
 	num++;
     }
 
-    printk ("hd%c%d: attempted read for sector %ld past end if image file at %ld.\n",
-	(dev >> 6) + 'a', dev & 0x3f, blk, totlen);
+    printk ("%s: attempted read for sector %ld past end if image file at %ld.\n",
+	kdevname (dev), blk, totlen);
 	/* Should never happen! */
     return 0;
 }
@@ -655,9 +685,9 @@
 #if 0
 static inline int check_bb(unsigned char *ptr)
 {
-	unsigned int result;
+    unsigned int result;
 	
-	__asm__("
+    __asm__("
 	adds	%3, %2, %3
 	sub	%3, %3, #1
 	b	LC02
@@ -667,8 +697,8 @@
 	mov	%0, %0, lsr #24
 LC02:	teqs	%2, %3
 	bne	LC01
-	" : "=r" (result) : "0" (0), "r" (ptr), "r" (512), "r" (256));
-	return result != ptr[511];
+    " : "=r" (result) : "0" (0), "r" (ptr), "r" (512), "r" (256));
+    return result != ptr[511];
 }
 
 static struct bootblock *bb;
@@ -680,13 +710,15 @@
 
     current_minor = minor;
 
+    /*
+     * read disk address &C00 for ADFS boot sectors
+     */
     if (!(bh = bread (dev, 3, 1024))) {
 	printk (" unable to read boot sectors\n");
 	return -1;
     }
 
-    if (check_bb (bh->b_data))
-    {
+    if (check_bb (bh->b_data)) {
 	brelse (bh);
 	return 0;
     }
@@ -700,10 +732,7 @@
     mapaddr    = ((bb->nzones >> 1) * zonesize - ((bb->nzones > 1)? RECSIZE*8 : 0)) << bb->log2bpmb;
     maplen     = bb->nzones << bb->log2secsize;
 
-    
-
     brelse (bh);
     return 1;
 }
 #endif
-
